
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Dev 日志 | 如何将 jar 包发布到 Maven 中央仓库 / 憋错料</title>

    <meta name="description" content="Dev 日志 | 如何将 jar 包发布到 Maven 中央仓库 摘要 Maven 中央仓库并不支持直接上传?jar?包,因此需要将 jar?包发布到一些指定的第三方?Maven?仓库,比如:Sonatype OSSRH 仓库,然后该仓库再将 jar?包同步到?Maven?,本文详细记录整个发布.同步过程. 注册一个 Sonatype 用户 进入地址:https://issues.sonatype.org/secure/Signup!default.jspa?注册 Sonatype 用户,Sonatype 通过 JIRA(JIRA 是 Atlassian 公司">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Dev 日志 | 如何将 jar 包发布到 Maven 中央仓库</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL29zY2ltZy5vc2NoaW5hLm5ldC9vc2NuZXQvdXAtYjg0MTdmODNjMmQzYWM2ODM4ZWNlMjVkN2FlYTNiOTQzZWYucG5n.jpg" /></p>
<h2>摘要</h2>
<p>Maven 中央仓库并不支持直接上传?jar?包，因此需要将 jar?包发布到一些指定的第三方?Maven?仓库，比如：Sonatype OSSRH 仓库，然后该仓库再将 jar?包同步到?Maven?，本文详细记录整个发布、同步过程。</p>
<h2>注册一个 Sonatype 用户</h2>
<p>进入地址：<a href="https://issues.sonatype.org/secure/Signup!default.jspa" rel="external nofollow noreferrer">https://issues.sonatype.org/secure/Signup!default.jspa</a>?注册 Sonatype 用户，Sonatype 通过 JIRA（JIRA 是 Atlassian 公司出品的项目与事务跟踪工具）来管理 OSSRH 仓库。</p>
<h2>创建一个发布构件的 issue</h2>
<p>提交「构件发布申请」的第一步是在?<a href="https://issues.sonatype.org/secure/Dashboard.jspa" rel="external nofollow noreferrer">JIRA Dashborad</a>?上创建一个 issue。如下所示，点击 <code>Create</code> 按钮：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItaW1hZ2VzLmdpdGh1YnVzZXJjb250ZW50LmNvbS81NjY0MzgxOS83MDYwNjY5OS0wNDBlMTcwMC0xYzM4LTExZWEtOWIxNi04MGQxNDdhNjAyMTAucG5n.jpg" /></p>
<p>会弹出一个对话框让你填写 issue 的详细信息，这里最重要的就是 Group Id，一般会带上域名，千万别弄错了，这关系到以后发布其它的构件。我们这里是<code>com.vesoft</code>。</p>
<p>Sonatype 有域名验证，验证方式:</p>
<ul>
<li>往你的 DNS 中添加 JIRA 编号记录</li>
<li>重定向到你的 Github 主页</li>
</ul>
<p>如果你没有域名，可参考这个链接：<a href="http://central.sonatype.org/pages/choosing-your-coordinates.html" rel="external nofollow noreferrer">http://central.sonatype.org/pages/choosing-your-coordinates.html</a>?的方法进行操作</p>
<ul>
<li>选择一个带有项目托管信息的 GroupId，例如 io.github.facebook 或 com.github.facebook</li>
<li>另外一种推荐的方式是使用免费的 free?managed security reporting service?
<ul>
<li>将?<a href="https://hackerone.com/central-security-project/reports/new" rel="external nofollow noreferrer">https://hackerone.com/central-security-project/reports/new</a>?作为你项目的安全信息保障 url，剩下的事情?Sonatype 工作人员会自行搞定。</li>
</ul>
</li>
</ul>
<h2>等待 issue 审核通过</h2>
<p>审核因为时差原因需要一定时间，审核通过后会收到邮件通知，同时在对应 issue 下会看到 Sonatype 工作人员的回复，一般是添加一个 comment，内容大致如下：</p>
<blockquote><p>Configuration has been prepared, now you can:<br />
Deploy snapshot artifacts into repository <a href="https://oss.sonatype.org/content/repositories/snapshots" rel="external nofollow noreferrer">https://oss.sonatype.org/content/repositories/snapshots</a><br />
Deploy release artifacts into the staging repository <a href="https://oss.sonatype.org/service/local/staging/" rel="external nofollow noreferrer">https://oss.sonatype.org/service/local/staging/</a> deploy/maven2<br />
Promote staged artifacts into repository ‘Releases‘<br />
Download snapshot and release artifacts from group <a href="https://oss.sonatype.org/content/groups/public" rel="external nofollow noreferrer">https://oss.sonatype.org/content/groups/public</a><br />
Download snapshot, release and staged artifacts from staging group <a href="https://oss.sonatype.org/content/groups/staging" rel="external nofollow noreferrer">https://oss.sonatype.org/content/groups/staging</a><br />
please comment on this ticket when you promoted your first release, thanks</p></blockquote>
<h2>使用 GPG 生成密钥对</h2>
<h3>生成密钥对</h3>
<pre><code>&gt; gpg --gen-key</code></pre>
<p>会让选择加密方式:</p>
<ul>
<li>RSA and RSA (default)</li>
<li>DSA and Elgamal</li>
<li>DSA (sign only)</li>
<li>RSA (sign only)</li>
</ul>
<p>默认选第一个，选择之后，需输入用户名和邮箱，和 Passphase——相当于密钥库密码。</p>
<h3>查看公钥</h3>
<pre><code>&gt; gpg --list-keys

xxx/.gnupg/pubring.gpg
---------------------------------
pub   2048R/xxxx 2019-12-02
uid   $YOUR_UID &lt;$YOUR_EMAIL&gt;
sub   2048R/**** 2019-12-02</code></pre>
<p>这里的公钥 ID 是?xxxx，马上就会用到了。</p>
<h3>将公钥上传到 PGP 密钥服务器</h3>
<pre><code>gpg --keyserver hkp://keys.gnupg.net:11371 --send-keys xxxx</code></pre>
<p>查看公钥是否上传成功</p>
<pre><code>&gt; gpg --keyserver hkp://keys.gnupg.net:11371 --recv-keys xxxx

gpg: 下载密钥‘xxxx’，从 hkp 服务器 keys.gnupg.net
gpg: 密钥 xxxx：“$YOUR_UID &lt;$YOUR_EMAIL&gt;”未改变
gpg: 合计被处理的数量：1
gpg: 未改变：1</code></pre>
<p>NOTE:?</p>
<ul>
<li>根据实际填写此处的公钥 ID</li>
<li>很多网上教程给的是? pool.sks-keyservers.net，个人感觉 pool.sks-keyservers.net 这个 keyserver 不好用，上传了 key，经常会验证失败，也获取失败，maven 支持两个 key servers?<a href="http://keys.gnupg.net:11371/" rel="external nofollow noreferrer">http://keys.gnupg.net:11371</a> 和 <a href="http://pool.sks-keyservers.net:11371/" rel="external nofollow noreferrer">http://pool.sks-keyservers.net:11371</a></li>
<li>此处采用 hkp 协议而不是 http 协议</li>
<li>很多教程没有给端口，经试验，<strong>需加上端口号</strong></li>
</ul>
<p>本地的私钥用来对上传的构件进行数字签名，而下载该构件的用户可通过上传的公钥来验证签名--需验证这个构件是否由本人上传的，因为存在构件被篡改的可能。</p>
<h2>修改 Maven 配置文件</h2>
<p>修改 Maven 配置文件主要是需要修改 <code>setting.xml</code>?和项目的 <code>pom.xml</code>?文件</p>
<h3>配置 Maven 的 setting.xml</h3>
<p>修改 <code>~/.m2/setting.xml</code>?文件</p>
<pre><code>&lt;settings xmlns=&quot;http://maven.apache.org/SETTINGS/1.0.0&quot;
          xmlns:xsi=&quot;http://www.w3.org/2001/XMLSchema-instance&quot;
          xsi:schemaLocation=&quot;http://maven.apache.org/SETTINGS/1.0.0
                      http://maven.apache.org/xsd/settings-1.0.0.xsd&quot;&gt;
    &lt;servers&gt;
      ...
        &lt;server&gt;
            &lt;id&gt;snapshots&lt;/id&gt;
            &lt;username&gt;$USER_NAME&lt;/username&gt;
            &lt;password&gt;$YOUR_PASSWORD&lt;/password&gt;
        &lt;/server&gt;
        &lt;server&gt;
            &lt;id&gt;release&lt;/id&gt;
            &lt;username&gt;$USER_NAME&lt;/username&gt;
            &lt;password&gt;$YOUR_PASSWORD&lt;/password&gt;
        &lt;/server&gt;
    &lt;/servers&gt;

&lt;/settings&gt;</code></pre>
<p>替换 <code>USER_NAME</code>?， <code>YOUR_PASSWORD</code>?为?Sonatype 上面注册的用户名和密码， 这里的 ID 会在 <code>pom.xml</code>?里面使用到。</p>
<h3>配置 Maven 的 pom.xml</h3>
<pre><code>&lt;project&gt;
    ...

    &lt;!-- More Project Information --&gt;
    &lt;name&gt;nebula-java&lt;/name&gt;
    &lt;description&gt;Nebula Java Client&lt;/description&gt;
    &lt;url&gt;https://github.com/vesoft-inc/nebula-java&lt;/url&gt;
    &lt;scm&gt;
        &lt;connection&gt;scm:git:https://github.com/vesoft-inc/nebula&lt;/connection&gt;
        &lt;url&gt;https://github.com/vesoft-inc/nebula&lt;/url&gt;
        &lt;developerConnection&gt;scm:git:https://github.com/vesoft-inc/nebula&lt;/developerConnection&gt;
    &lt;/scm&gt;
    &lt;licenses&gt;
        &lt;license&gt;
            &lt;name&gt;Apache License, Version 2.0&lt;/name&gt;
            &lt;url&gt;https://www.apache.org/licenses/LICENSE-2.0.txt&lt;/url&gt;
            &lt;distribution&gt;repo&lt;/distribution&gt;
            &lt;comments&gt;license&lt;/comments&gt;
        &lt;/license&gt;
    &lt;/licenses&gt;

    ...
    &lt;profiles&gt;
        &lt;profile&gt;
            &lt;id&gt;release&lt;/id&gt;
            &lt;build&gt;
                &lt;plugins&gt;
                    &lt;!-- Source --&gt;
                    &lt;plugin&gt;
                        &lt;groupId&gt;org.apache.maven.plugins&lt;/groupId&gt;
                        &lt;artifactId&gt;maven-source-plugin&lt;/artifactId&gt;
                        &lt;executions&gt;
                            &lt;execution&gt;
                                &lt;id&gt;attach-sources&lt;/id&gt;
                                &lt;goals&gt;
                                    &lt;goal&gt;jar&lt;/goal&gt;
                                &lt;/goals&gt;
                            &lt;/execution&gt;
                        &lt;/executions&gt;
                    &lt;/plugin&gt;
                    &lt;!-- Javadoc --&gt;
                    &lt;plugin&gt;
                        &lt;groupId&gt;org.apache.maven.plugins&lt;/groupId&gt;
                        &lt;artifactId&gt;maven-javadoc-plugin&lt;/artifactId&gt;
                        &lt;version&gt;3.1.1&lt;/version&gt;
                        &lt;configuration&gt;
                            &lt;excludePackageNames&gt;com.facebook.thrift:com.facebook.thrift.*&lt;/excludePackageNames&gt;
                        &lt;/configuration&gt;
                        &lt;executions&gt;
                            &lt;execution&gt;
                                &lt;id&gt;attach-javadocs&lt;/id&gt;
                                &lt;phase&gt;package&lt;/phase&gt;
                                &lt;goals&gt;
                                    &lt;goal&gt;jar&lt;/goal&gt;
                                &lt;/goals&gt;
                                &lt;configuration&gt;
                                    &lt;doclint&gt;none&lt;/doclint&gt;
                                &lt;/configuration&gt;
                            &lt;/execution&gt;
                        &lt;/executions&gt;
                    &lt;/plugin&gt;
                    &lt;!-- GPG --&gt;
                    &lt;plugin&gt;
                        &lt;groupId&gt;org.apache.maven.plugins&lt;/groupId&gt;
                        &lt;artifactId&gt;maven-gpg-plugin&lt;/artifactId&gt;
                        &lt;version&gt;1.6&lt;/version&gt;
                        &lt;executions&gt;
                            &lt;execution&gt;
                                &lt;phase&gt;verify&lt;/phase&gt;
                                &lt;goals&gt;
                                    &lt;goal&gt;sign&lt;/goal&gt;
                                &lt;/goals&gt;
                            &lt;/execution&gt;
                        &lt;/executions&gt;
                    &lt;/plugin&gt;
                &lt;/plugins&gt;
            &lt;/build&gt;
            &lt;distributionManagement&gt;
                &lt;repository&gt;
                    &lt;id&gt;release&lt;/id&gt;
                    &lt;url&gt;https://oss.sonatype.org/service/local/staging/deploy/maven2/&lt;/url&gt;
                &lt;/repository&gt;
                &lt;snapshotRepository&gt;
                    &lt;id&gt;snapshots&lt;/id&gt;
                    &lt;url&gt;https://oss.sonatype.org/content/repositories/snapshots/&lt;/url&gt;
                &lt;/snapshotRepository&gt;
            &lt;/distributionManagement&gt;
        &lt;/profile&gt;
    &lt;/profiles&gt;
    ...
&lt;/project&gt;</code></pre>
<ul>
<li>pom.xml 中必须包括： <code>name</code>?、 <code>description</code>?、 <code>url</code>?、 <code>licenses</code>?、 <code>developers</code>?、 <code>scm</code>?等基本信息 （<del>血泪史之踩过的坑</del>）</li>
<li><strong>发布 maven 除了 jar 必须还有文档包和源码包</strong>。因此 pom 需添加 <code>maven-javadoc-plugin</code>? 和? <code>maven-source-plugin</code> 。 参考示例:</li>
</ul>
<pre><code>com-vesoft-client
|-- pom.xml
|-- src`-- target
    `-- attach-source-javadoc-1.0-SNAPSHOT.jar
    `-- attach-source-javadoc-1.0-SNAPSHOT-javadoc.jar
    `-- attach-source-javadoc-1.0-SNAPSHOT-sources.jar</code></pre>
<ul>
<li>发布构建需要秘钥加密，因此 pom 需添加 <code>maven-gpg-plugin</code>? （<del>血泪史之踩过的坑</del>）</li>
</ul>
<h3>多模块项目配置</h3>
<p>nebula-java 是多模块项目</p>
<pre><code>&lt;modules&gt;
    &lt;module&gt;client&lt;/module&gt;
    &lt;module&gt;examples&lt;/module&gt;
&lt;/modules&gt;</code></pre>
<p>为了上传 Client，需要上传 parent 的 pom.xml，否则 Client 会找不到依赖（<del>血泪史之踩过的坑</del>），但我们又不希望上传 examples 模块，故做了如下改动:?</p>
<ul>
<li>项目信息 <code>name</code> 、 <code>description</code> 、 <code>url</code> 、 <code>licenses</code> 、 <code>developers</code> 、 <code>scm</code>?等信息和 <code>maven-gpg-plugin</code>?放在 parent 的 pom.xml 文件中</li>
</ul>
<pre><code>&lt;project&gt;
  ...
    &lt;name&gt;nebula-java&lt;/name&gt;
    &lt;description&gt;Nebula Java Client&lt;/description&gt;
    &lt;url&gt;https://github.com/vesoft-inc/nebula-java&lt;/url&gt;
    &lt;scm&gt;
        &lt;connection&gt;scm:git:https://github.com/vesoft-inc/nebula&lt;/connection&gt;
        &lt;url&gt;https://github.com/vesoft-inc/nebula&lt;/url&gt;
        &lt;developerConnection&gt;scm:git:https://github.com/vesoft-inc/nebula&lt;/developerConnection&gt;
    &lt;/scm&gt;
    &lt;licenses&gt;
        &lt;license&gt;
            &lt;name&gt;Apache License, Version 2.0&lt;/name&gt;
            &lt;url&gt;https://www.apache.org/licenses/LICENSE-2.0.txt&lt;/url&gt;
            &lt;distribution&gt;repo&lt;/distribution&gt;
            &lt;comments&gt;license&lt;/comments&gt;
        &lt;/license&gt;
    &lt;/licenses&gt;

    &lt;developers&gt;
        &lt;developer&gt;
            &lt;id&gt;$ID&lt;/id&gt;
            &lt;name&gt;$NAME&lt;/name&gt;
            &lt;email&gt;$EMAIL&lt;/email&gt;
            &lt;organization&gt;vesoft&lt;/organization&gt;
            &lt;roles&gt;
                &lt;role&gt;architect&lt;/role&gt;
                &lt;role&gt;developer&lt;/role&gt;
            &lt;/roles&gt;
        &lt;/developer&gt;
    &lt;/developers&gt;

    &lt;distributionManagement&gt;
        &lt;repository&gt;
            &lt;id&gt;release&lt;/id&gt;
            &lt;url&gt;https://oss.sonatype.org/service/local/staging/deploy/maven2/&lt;/url&gt;
        &lt;/repository&gt;
        &lt;snapshotRepository&gt;
            &lt;id&gt;snapshots&lt;/id&gt;
            &lt;url&gt;https://oss.sonatype.org/content/repositories/snapshots/&lt;/url&gt;
        &lt;/snapshotRepository&gt;
    &lt;/distributionManagement&gt;

    &lt;build&gt;
        &lt;plugins&gt;
            &lt;plugin&gt;
                &lt;groupId&gt;org.apache.maven.plugins&lt;/groupId&gt;
                &lt;artifactId&gt;maven-gpg-plugin&lt;/artifactId&gt;
                &lt;version&gt;1.6&lt;/version&gt;
                &lt;executions&gt;
                    &lt;execution&gt;
                        &lt;phase&gt;verify&lt;/phase&gt;
                        &lt;goals&gt;
                            &lt;goal&gt;sign&lt;/goal&gt;
                        &lt;/goals&gt;
                    &lt;/execution&gt;
                &lt;/executions&gt;
            &lt;/plugin&gt;
        &lt;/plugins&gt;
    &lt;/build&gt;
  &lt;/project&gt;</code></pre>
<ul>
<li>在 Java Client 的 pom.xml 中添加 <code>maven-javadoc-plugin</code>? 、? <code>maven-source-plugin</code>?和?<code>maven-deploy-plugin</code></li>
</ul>
<pre><code>&lt;plugins&gt;
  ......
    &lt;plugin&gt;
        &lt;groupId&gt;org.apache.maven.plugins&lt;/groupId&gt;
        &lt;artifactId&gt;maven-source-plugin&lt;/artifactId&gt;
        &lt;executions&gt;
            &lt;execution&gt;
                &lt;id&gt;attach-sources&lt;/id&gt;
                &lt;goals&gt;
                    &lt;goal&gt;jar&lt;/goal&gt;
                &lt;/goals&gt;
            &lt;/execution&gt;
        &lt;/executions&gt;
    &lt;/plugin&gt;
    &lt;plugin&gt;
        &lt;groupId&gt;org.apache.maven.plugins&lt;/groupId&gt;
        &lt;artifactId&gt;maven-javadoc-plugin&lt;/artifactId&gt;
        &lt;version&gt;3.1.1&lt;/version&gt;
        &lt;configuration&gt;
            &lt;excludePackageNames&gt;com.facebook.thrift:com.facebook.thrift.*&lt;/excludePackageNames&gt;
        &lt;/configuration&gt;
        &lt;executions&gt;
            &lt;execution&gt;
                &lt;id&gt;attach-javadocs&lt;/id&gt;
                &lt;phase&gt;package&lt;/phase&gt;
                &lt;goals&gt;
                    &lt;goal&gt;jar&lt;/goal&gt;
                &lt;/goals&gt;
                &lt;configuration&gt;
                    &lt;doclint&gt;none&lt;/doclint&gt;
                &lt;/configuration&gt;
            &lt;/execution&gt;
        &lt;/executions&gt;
    &lt;/plugin&gt;
    &lt;plugin&gt;
        &lt;groupId&gt;org.apache.maven.plugins&lt;/groupId&gt;
        &lt;artifactId&gt;maven-deploy-plugin&lt;/artifactId&gt;
        &lt;executions&gt;
            &lt;execution&gt;
                &lt;id&gt;default-deploy&lt;/id&gt;
                &lt;phase&gt;deploy&lt;/phase&gt;
            &lt;/execution&gt;
        &lt;/executions&gt;
    &lt;/plugin&gt;
&lt;/plugins&gt;</code></pre>
<p>在 example 模块的 pom.xml 中声明 skip deploy</p>
<pre><code>&lt;plugins&gt;
  ......
    &lt;plugin&gt;
        &lt;groupId&gt;org.apache.maven.plugins&lt;/groupId&gt;
        &lt;artifactId&gt;maven-deploy-plugin&lt;/artifactId&gt;
        &lt;configuration&gt;
            &lt;skip&gt;true&lt;/skip&gt;
        &lt;/configuration&gt;
    &lt;/plugin&gt;
&lt;/plugins&gt;</code></pre>
<p>Q: 为什么 <code>maven-gpg-plugin</code> 放在 parent 的 pom.xm l中，而 <code>maven-javadoc-plugin</code>，<code>maven-source-plugin</code>?插件放在 Client 的 pom.xml 中</p>
<p>A: 因为上传的所有构件都需要加密，包括 parent 的 pom.xml，因此放在 parent 中； 而只有 Client 需要上传 javadoc，source，因此 <code>maven-javadoc-plugin</code>，<code>maven-source-plugin</code>?插件放在 Client 中。</p>
<h2>上传构件到 OSS 中</h2>
<p>在 nebula-java/ 目录下运行：</p>
<pre><code>&gt; mvn clean deploy -DpomFile=pom.xml</code></pre>
<blockquote><p>NOTE：不加 -DpomFile ，上传的文件中会没有 parent 的 pom.xml (<del>又是一部血泪史</del>)</p></blockquote>
<h2>在 OSS 中发布构件</h2>
<p>使用 Sonatype 账号登录 <a href="https://oss.sonatype.org/#stagingRepositories" rel="external nofollow noreferrer">https://oss.sonatype.org/#stagingRepositories</a>，可在 <code>Staging Repositories</code>? 中查看已上传的构件，这些构件目前是放在 Staging 仓库中，可进行模糊查询，定位到刚上传的构件。</p>
<p>此时，该构件的状态为 <code>Open</code> ，勾选它，然后点击 <code>Close</code>? 按钮。系统会自动验证该构件是否满足指定要求 (幸福的人只有一种，不幸的人各有各的不幸，可能会遇到各种各样的不符合要求，Good luck！ヾ(?°?°?)??)</p>
<p>当验证完毕后，状态会变为 <code>Closed</code> 。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItaW1hZ2VzLmdpdGh1YnVzZXJjb250ZW50LmNvbS81NjY0MzgxOS83MDYwNjcxMC0wYTAzZjgwMC0xYzM4LTExZWEtOWYxMy1lYzZhMTEyNzFhNWMucG5n.jpg" /></p>
<p>最后，点击 <code>Release</code> 按钮来发布该构件</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItaW1hZ2VzLmdpdGh1YnVzZXJjb250ZW50LmNvbS81NjY0MzgxOS83MDYwNjcxOC0wY2ZlZTg4MC0xYzM4LTExZWEtOTdiMi1iMDQ1MDI4ZWE4YTYucG5n.jpg" /></p>
<p>页面可能要刷新一下才能看到最新的状态。</p>
<h2>通知 Sonatype 构件已成功发布</h2>
<p>在前面 JIRA 的 issue 下面回复一条“构件已成功发布”的评论，通知 Sonatype 的工作人员为要发布的构件做审批，发布后会关闭该 issue。</p>
<h2>等待构件审批通过</h2>
<p>然后，等待。。。</p>
<h2>从中央仓库中搜索构件</h2>
<p>大概十多分钟后，可以在这里 <a href="https://repo1.maven.org/maven2" rel="external nofollow noreferrer">https://repo1.maven.org/maven2</a> 找到刚刚发布的构件，可以直接在 pom.xml 中使用啦~~ ????</p>
<p>等同步完成大约 2 个小时，中央仓库（连接：<a href="https://search.maven.org/" rel="external nofollow noreferrer">http://search.maven.org/</a>）就可以搜到啦。</p>
<p>国内很多使用的是阿里云的镜像，镜像同步不是实时同步。为了及时使用，可以添加中央仓库镜像源，在?<code>~/.m2/setting.xml</code>?文件添加，如下：</p>
<pre><code>&lt;mirrors&gt;
......
    &lt;mirror&gt;
        &lt;id&gt;nexus-mvn&lt;/id&gt;
        &lt;mirrorOf&gt;central&lt;/mirrorOf&gt;
        &lt;name&gt;Nexus Central&lt;/name&gt;
        &lt;url&gt;http://repo1.maven.org/maven2&lt;/url&gt;
    &lt;/mirror&gt;
&lt;/mirrors&gt;</code></pre>
<p>第一次成功发布之后，以后就不用这么麻烦了，可以直接使用 Group Id 发布构件。</p>
<h2>后续操作</h2>
<p>之后同一个 Group Id 的发布流程</p>
<ul>
<li>按照上文编辑 setting.xml 和 pom.xml，</li>
<li>上传构建；</li>
<li>在 <a href="https://oss.sonatype.org/" rel="external nofollow noreferrer">https://oss.sonatype.org/</a> close 并 release 构件；</li>
<li>等待同步完成（大约 2 小时）后，就可以使用了</li>
</ul>
<p>最后温馨提示：发布的版本不支持修改，或者删除</p>
<h2>星云·小剧场</h2>
<p><strong>为什么给图数据库取名 Nebula ？</strong><br />
Nebula 是星云的意思，很大嘛，也是漫威宇宙里面漂亮的星云小姐姐。对了，Nebula的发音是：[?n?bj?l?]</p>
<p>本文星云图讲解--《阿尔普 188 和蝌蚪的尾巴》</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItaW1hZ2VzLmdpdGh1YnVzZXJjb250ZW50LmNvbS81NjY0MzgxOS83MDYwNjY5Mi1mZTE4MzYwMC0xYzM3LTExZWEtOWVjNS01NWNmZjc5ZmU1ZjAucG5n.jpg" /></p>
<p>为什么这个星系有这么长的尾巴?</p>
<p>在这张令人惊叹的远景图中，根据哈勃遗留档案的图像数据，遥远的星系形成了一个引人注目的背景，这是被破坏的螺旋星系 Arp188，蝌蚪星系。</p>
<p>宇宙蝌蚪距离北方的龙星座(天龙座)只有 4.2 亿光年。它引人注目的尾巴大约有 28 万光年长，以巨大、明亮的蓝色星团为特征。有一个故事是这样说的：一个更致密的闯入星系从 Arp 188 前穿过——从右到左——被它们的引力甩在蝌蚪后面。在这次近距离接触中，潮汐力将螺旋星系的恒星、气体和尘埃拉出，形成了壮观的尾巴。闯入者星系本身，估计位于蝌蚪后面 30 万光年处，可以通过右上角的前景螺旋臂看到。与地球同名的蝌蚪星系很可能会随着年龄的增长而失去尾巴，尾巴上的星团形成了大螺旋星系的小卫星。</p>
<p>资料来源 | Hubble Legacy Archive, ESA, NASA;</p>
<p>图片来源 | Astronomy Picture of the Day | 2018 December 11</p>
<h2>附录</h2>
<p>最后，附上 Nebula Graph GitHub 地址：<a href="https://0x7.me/icnblog2github" rel="external nofollow noreferrer">https://github.com/vesoft-inc/nebula</a>，如果你在使用 Nebula Graph 过程中遇到任何问题，欢迎 GitHub 联系我们或者加入微信交流群，请联系微信号：NebulaGraphbot</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItaW1hZ2VzLmdpdGh1YnVzZXJjb250ZW50LmNvbS81NjY0MzgxOS83MDMxMTI2Ny00OTlmOWUwMC0xODRjLTExZWEtODZhYy00MmQ0YmMzODQ3OTQucG5n.jpg" /></p>

<p>原文地址：https://www.cnblogs.com/nebulagraph/p/12028833.html</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 21:14:37 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/cat/" title="cat">cat</a>, <a href="https://www.biecuoliao.com/tag/%e6%9c%ac%e5%9c%b0/" title="本地">本地</a>, <a href="https://www.biecuoliao.com/tag/china/" title="china">china</a>, <a href="https://www.biecuoliao.com/tag/uid/" title="uid">uid</a>, <a href="https://www.biecuoliao.com/tag/arc/" title="arc">arc</a>, <a href="https://www.biecuoliao.com/tag/%e5%85%8d%e8%b4%b9/" title="免费">免费</a>, <a href="https://www.biecuoliao.com/tag/board/" title="board">board</a>, <a href="https://www.biecuoliao.com/tag/%e8%81%94%e7%b3%bb%e6%88%91%e4%bb%ac/" title="联系我们">联系我们</a>, <a href="https://www.biecuoliao.com/tag/rap/" title="rap">rap</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Dev 日志 | 如何将 jar 包发布到 Maven 中央仓库的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0KnkOJM.html" rel="bookmark">将 jar 包发布到Maven中央仓库</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这里列出一些发布过程中的注意点: 1. javadocs 的验证非常严格,在上传 javadoc 时需要做降级处理,关闭doclint.maven plugin 配置如下: &lt;plugin&gt; &lt;groupId&gt;org.apache.maven.plugins&lt;/groupId&gt; &lt;artifactId&gt;maven-javadoc-plugin&lt;/artifactId&gt; &lt;version&gt;2.9.1&lt;/version&gt; &l			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/XMg1qp3.html" rel="bookmark">一份可以发布到MAVEN中央仓库的POM</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今天在家折腾了一下怎么把Jar包发布到Maven的中央仓库,基本步骤百毒一堆,但基本上都是让引用sonatype的parent pom,个人感觉这份pom并不好用,于是自己写了一个,同时这个pom也是Spring MVC + Hibernate + Spring Security开发的基本pom,有兴趣的童鞋可以参考一下. &lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot;?&gt; &lt;project xmlns=&quot;htt			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/w3vDvXM.html" rel="bookmark">喜大普奔，微软Microsoft JDBC Driver For SQL Server已发布到maven中央仓库</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				相信通过java和SQLServer开发应用的同学们都经历过如下类似的问题. 微软提供的JDBC官方驱动没有放置在Maven仓库中,这样如果你的Java应用需要访问SQL Server,你不得不下载sqljdbc4.jar至本地,然后每次都通过如下Maven命令安装这一驱动: mvn install:install-file -DgroupId=com.microsoft.sqlserver -DartifactId=sqljdbc4 -Dversion=4.0 -Dpackaging=jar			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBWVxg0.html" rel="bookmark">把本地jar包发布到maven私服和本地maven库</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				有时时候下载了jar包,但发现maven库里没有,可以将jar包上传到本地私服和本地maven库: 1.上传到本地私服 mvn deploy:deploy-file -Dfile=D:\GETUI_SERVER_SDK\资源文件\gexin-rp-sdk-base-4.0.0.1.jar -DgroupId=com.gexin.rp.sdk -DartifactId=gexin-rp-sdk-base -Dversion=4.0.0.1 -Dpackaging=jar -Durl=http://			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qaNRW3.html" rel="bookmark">如何把jar包发布到maven私服</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.格式 mvn deploy:deploy-file -DgroupId=com.qiyi -DartifactId=sphinx -Dversion=1.0 -Dpackaging=jar -Dfile=D:\sphinxapi.jar -Durl=[url] -DrepositoryId=[id 2.实例 D:\develop\apache-maven-3.0.4\bin&gt;mvn deploy:deploy-file -DgroupId=org.sphx -DartifactId=sphi			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4952g14.html" rel="bookmark">将第三方包安装到maven本地仓库</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今天在做jasper report生成pdf文档的时候,需要引入亚洲字体jar包.maven仓库是有这个jar包,但是在项目pom文件始终不能下载.无奈只有将jar包安装到maven本地仓库. 1 将jar包放到电脑的某个位置,如:C:\E\Received\FireFox\itext-asiancmaps-5.1.1.jar 2 执行命令 cd C:\E\Received\FireFox\ 3 执行命令 mvn install:install-file -DgroupId=com.itextp			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/47Nwx93.html" rel="bookmark">设置将Maven的jar包发布到lib</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2,设置将Maven的jar包发布到lib下. Add -&gt; Java Build Path Entries -&gt; Maven Dependencies -&gt; Finish 设置完成效果图			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzEVLy4.html" rel="bookmark">添加jar包到本地Maven仓库</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在使用Maven的过程中,经常碰到有些jar包在中央仓库没有的情况.如果公司有私服,那么就把jar包安装到私服上.如果没有私服,那就把jar包安装到本地Maven仓库.今天介绍2种安装jar包到本地Maven仓库的方法,下面进入正题. 一.使用Maven命令安装jar包 前提:在windows操作系统中配置好了Maven的环境变量,怎么配置请自己百度,这里不介绍,可参考https://jingyan.baidu.com/article/cb5d61050b8ee7005d2fe04e.html			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MygNZn3.html" rel="bookmark">【maven】idea的pom文件修改，引入新的jar包，无效，本地仓库始终没有下载新jar包的问题解决【idea  pom Dependency  not found】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				引入问题: idea的pom文件修改,引入新的jar包,无效,本地仓库始终没有下载新jar包的问题解决[idea  pom Dependency  not found] 如题,引入一个新的jar包,在项目的pom文件中: &lt;!-- 阿里巴巴easyexcel --&gt; &lt;dependency&gt; &lt;groupId&gt;com.alibaba&lt;/groupId&gt; &lt;artifactId&gt;easyexcel&lt;/artifactId&gt; &lt;ve			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/pMPN5v3.html" rel="bookmark" class="title">仿网易云音乐播放器（磁盘转圈、背景虚化等等）</a>
					<div>
						先看效果,CSDN的git传上去总是不动.不知道为什么. 主要思路: 1 . 除了 開始/暂停 .上一首.下一首 这三个icon.你看到的是一个ViewGroup ,这个ViewGroup里面有圆形封 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/n0lqlE3.html" rel="bookmark" class="title">yii，gridview隐藏查看（view）按钮</a>
					<div>
						修改: ['class' =&gt; 'yii\grid\ActionColumn'], 为: [     'class' =&gt; 'yii\grid\ActionColumn',     'te ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/E3wzjV0.html" rel="bookmark" class="title">详解Bottle模板</a>
					<div>
						今天和大家分享一下自己在学习Bottle框架的过程中总结的关于模板的知识点,希望对大家有帮助. Bottle 使用自带的小巧的模板. 你可以使用调用 template(template_name, * ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JzvzY4.html" rel="bookmark" class="title">如何在mysql中存储音乐和图片文件</a>
					<div>
						如何在mysql中存储音乐和图片文件? 果你想把二进制的数据,比如说图片文件和HTML文件,直接保存在你的MySQL数据库,那么这篇文章就是为你而写的! 我将告诉你怎样通过HTML表单来储存这些文件, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02DxqE4.html" rel="bookmark" class="title">Java&lpar;15&rpar; 多态</a>
					<div>
						一.多态  1.1 多态:一个事物的多种形态  1.2 多态的表现 行为(方法)多态:重写和重载. 引用多态(动态绑定):编译时的类型和运行时不一致的这种现象 例:父类 = 子类 Pet p = ne ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YYB8N0.html" rel="bookmark" class="title">手动安装yii2&period;0-redis扩展</a>
					<div>
						1.点击下载:yii2.0-redis扩展 2.把下载的扩展文件放到vendor/yiisoft/下,命名为yii2-redis 3.修改vender/yiisoft/下的extensions.php ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXQGdQ0.html" rel="bookmark" class="title">20160621&lowbar;Task&lowbar;03&lowbar;Menu&lowbar;List</a>
					<div>
						city = (,,) sh_district = (,,) bj_district = (,,) sz_district = (,,) sh_mh_street = (,,) sh_xh_stree ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBaYZE4.html" rel="bookmark" class="title">用一条SQL语句取出第 m 条到第 n 条记录的方法</a>
					<div>
						原文:用一条SQL语句取出第 m 条到第 n 条记录的方法   --从Table 表中取出第 m 条到第 n 条的记录:(Not In 版本) SELECT TOP n-m+1 * FROM Tabl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41o1pq0.html" rel="bookmark" class="title">关于overfit的随笔</a>
					<div>
						看到@ 爱可可-爱生活转发的文章.稍微看了下,在这里记录下. overfit是机器学习的一个重要概念.在狭义上可以定义为模型过于复杂,导致模型的generalization不够好.我认为应采用一个广义 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xZN1n4.html" rel="bookmark" class="title">数据结构-链表快排</a>
					<div>
						1 #include&lt;cstdio&gt; 2 #include&lt;cstdlib&gt; 3 #include&lt;string&gt; 4 5 struct Node{ 6 int n ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6l1Xv3.html" rel="bookmark" class="title">解决配置数据库时Could not load JDBC driver class问题</a>
					<div>
						运用Spring+Hibenate+Struts2+Oracle数据库时: 出现这种错误的应该先检查applicationContext文件下的 &lt;property name=&quot;dri ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lNGJB4.html" rel="bookmark" class="title">鼠标右击事件</a>
					<div>
						鼠标左击事件是我们常常遇到的,那么,如何写一个鼠标右击事件呢? 通常,鼠标有三个键:左键(1).中键(2).右键(3),jQuery通过e.which即可判断点击了哪一个按键,如果不通过e.which ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6XNVy3.html" rel="bookmark" class="title">json的一般处理（增加、修改、删除、遍历）</a>
					<div>
						&lt;script type=&quot;text/javascript&quot;&gt;         var json = {             &quot;age&quot;:24, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEjK1D0.html" rel="bookmark" class="title">项目数据分析师学习数据分析课程</a>
					<div>
						项目数据分析师(英文简称CPDA)是专业从事投资和运营项目数据分析的高级决策人,通过掌握大量行业数据以及科学的计算工具,将经济学原理用数学模型表示,科学合理的分析投资和运营项目未来的收益及风险情况,为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35NEOn4.html" rel="bookmark" class="title">Spark On YARN内存分配</a>
					<div>
						本文转自:http://blog.javachen.com/2015/06/09/memory-in-spark-on-yarn.html?utm_source=tuicool 此文解决了Spark  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0klqZE3.html" rel="bookmark" class="title">漂亮的信息提示，给大家分享下 希望对大家有用</a>
					<div>
						漂亮 用户体验友好 信息提示 HTML结构: &lt;div class=&quot;msg24&quot;&gt; &lt;p class=&quot;ok&quot;&gt; 默认地址修改成功!  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0klqNj3.html" rel="bookmark" class="title">mac office软件的安装与破解</a>
					<div>
						1.mac  office 软件的安装及破解  http://10176523.cn/archives/29/ 下载后安装  切记不要登录 然后用这个文件 破解					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgQgYp3.html" rel="bookmark" class="title">Yii2&period;0 Gridview为某列增加属性</a>
					<div>
						我们知道GridView组件非常方便,会自动生成数据表格.table tr td神马的全自动生成的.但是如果想定制化稍微有点难度. 比如想在某列td上应用样式. 老写法是这样的 &lt;?= Grid ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWd1ll0.html" rel="bookmark" class="title">解除svn版本控制</a>
					<div>
						步骤1.去除目录下的所有.svn文件夹:两种方式: 方法1:搜索目录下所有.svn文件,删除: 方法2:复制下列文字到txt中,然后把扩展名改为reg,放到需要去除.svn的目录中,双击运行注册表即可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35nB6E4.html" rel="bookmark" class="title">佳木斯</a>
					<div>
						自传13.在佳木斯煤机厂----打铁锻练 一九六八年九月二十日我乘坐火车离开天津站直向东北方向开跋.一路上我提笔写成了一首&lt;咏志(七律)&gt;诗把我的感想尽情地抒发:年少岂能做井蛙,志在地角与 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.023 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
